diff --git a/app/test/test_bitratestats.c b/app/test/test_bitratestats.c
index 1ff540f4c4..926133de58 100644
--- a/app/test/test_bitratestats.c
+++ b/app/test/test_bitratestats.c
@@ -249,4 +249,4 @@ test_bitratestats(void)
 {
 	return unit_test_suite_runner(&bitratestats_testsuite);
 }
-REGISTER_TEST_COMMAND(bitratestats_autotest, test_bitratestats);
+REGISTER_FAST_TEST(bitratestats_autotest, true, true, test_bitratestats);
diff --git a/app/test/test_compressdev.c b/app/test/test_compressdev.c
index fbecaf9aaa..81b8e02006 100644
--- a/app/test/test_compressdev.c
+++ b/app/test/test_compressdev.c
@@ -4267,4 +4267,4 @@ test_compressdev(void)
 	return unit_test_suite_runner(&compressdev_testsuite);
 }
 
-REGISTER_TEST_COMMAND(compressdev_autotest, test_compressdev);
+REGISTER_FAST_TEST(compressdev_autotest, false, true, test_compressdev);
diff --git a/app/test/test_cryptodev.c b/app/test/test_cryptodev.c
index 956268bfcd..5b2a908a6f 100644
--- a/app/test/test_cryptodev.c
+++ b/app/test/test_cryptodev.c
@@ -17439,7 +17439,7 @@ test_cryptodev_scheduler(void)
 	return ret;
 }
 
-REGISTER_TEST_COMMAND(cryptodev_scheduler_autotest, test_cryptodev_scheduler);
+REGISTER_DRIVER_TEST(cryptodev_scheduler_autotest, test_cryptodev_scheduler);
 
 #endif
 
diff --git a/app/test/test_cryptodev_asym.c b/app/test/test_cryptodev_asym.c
index 3d5a73bf89..9820b80f7e 100644
--- a/app/test/test_cryptodev_asym.c
+++ b/app/test/test_cryptodev_asym.c
@@ -2825,8 +2825,7 @@ test_cryptodev_cn10k_asym(void)
 	return unit_test_suite_runner(&cryptodev_octeontx_asym_testsuite);
 }
 
-REGISTER_TEST_COMMAND(cryptodev_openssl_asym_autotest,
-					  test_cryptodev_openssl_asym);
+REGISTER_DRIVER_TEST(cryptodev_openssl_asym_autotest, test_cryptodev_openssl_asym);
 
 REGISTER_DRIVER_TEST(cryptodev_qat_asym_autotest, test_cryptodev_qat_asym);
 
diff --git a/app/test/test_event_eth_tx_adapter.c b/app/test/test_event_eth_tx_adapter.c
index 616c972ac0..dbd22f6800 100644
--- a/app/test/test_event_eth_tx_adapter.c
+++ b/app/test/test_event_eth_tx_adapter.c
@@ -1006,5 +1006,4 @@ test_event_eth_tx_adapter_common(void)
 
 #endif /* !RTE_EXEC_ENV_WINDOWS */
 
-REGISTER_TEST_COMMAND(event_eth_tx_adapter_autotest,
-		test_event_eth_tx_adapter_common);
+REGISTER_FAST_TEST(event_eth_tx_adapter_autotest, false, true, test_event_eth_tx_adapter_common);
diff --git a/app/test/test_eventdev.c b/app/test/test_eventdev.c
index 29354a24c9..c51c93bdbd 100644
--- a/app/test/test_eventdev.c
+++ b/app/test/test_eventdev.c
@@ -1259,9 +1259,8 @@ test_eventdev_selftest_cn10k(void)
 REGISTER_FAST_TEST(eventdev_common_autotest, true, true, test_eventdev_common);
 
 #ifndef RTE_EXEC_ENV_WINDOWS
-REGISTER_TEST_COMMAND(eventdev_selftest_sw, test_eventdev_selftest_sw);
-REGISTER_TEST_COMMAND(eventdev_selftest_octeontx,
-		test_eventdev_selftest_octeontx);
+REGISTER_DRIVER_TEST(eventdev_selftest_sw, test_eventdev_selftest_sw);
+REGISTER_DRIVER_TEST(eventdev_selftest_octeontx, test_eventdev_selftest_octeontx);
 REGISTER_TEST_COMMAND(eventdev_selftest_dpaa2, test_eventdev_selftest_dpaa2);
 REGISTER_TEST_COMMAND(eventdev_selftest_dlb2, test_eventdev_selftest_dlb2);
 REGISTER_TEST_COMMAND(eventdev_selftest_cn9k, test_eventdev_selftest_cn9k);
diff --git a/app/test/test_graph.c b/app/test/test_graph.c
index af90ac07ec..371b6080eb 100644
--- a/app/test/test_graph.c
+++ b/app/test/test_graph.c
@@ -989,7 +989,7 @@ graph_autotest_fn(void)
 	return unit_test_suite_runner(&graph_testsuite);
 }
 
-REGISTER_TEST_COMMAND(graph_autotest, graph_autotest_fn);
+REGISTER_FAST_TEST(graph_autotest, true, true, graph_autotest_fn);
 
 static int
 test_node_list_dump(void)
@@ -1001,4 +1001,4 @@ test_node_list_dump(void)
 
 #endif /* !RTE_EXEC_ENV_WINDOWS */
 
-REGISTER_TEST_COMMAND(node_list_dump, test_node_list_dump);
+REGISTER_FAST_TEST(node_list_dump, true, true, test_node_list_dump);
diff --git a/app/test/test_graph_perf.c b/app/test/test_graph_perf.c
index c5b463f700..983735c2d9 100644
--- a/app/test/test_graph_perf.c
+++ b/app/test/test_graph_perf.c
@@ -1073,4 +1073,4 @@ test_graph_perf_func(void)
 
 #endif /* !RTE_EXEC_ENV_WINDOWS */
 
-REGISTER_TEST_COMMAND(graph_perf_autotest, test_graph_perf_func);
+REGISTER_PERF_TEST(graph_perf_autotest, test_graph_perf_func);
diff --git a/app/test/test_latencystats.c b/app/test/test_latencystats.c
index db06c7d5c7..c309ab194f 100644
--- a/app/test/test_latencystats.c
+++ b/app/test/test_latencystats.c
@@ -216,4 +216,4 @@ static int test_latencystats(void)
 	return unit_test_suite_runner(&latencystats_testsuite);
 }
 
-REGISTER_TEST_COMMAND(latencystats_autotest, test_latencystats);
+REGISTER_FAST_TEST(latencystats_autotest, true, true, test_latencystats);
diff --git a/app/test/test_link_bonding.c b/app/test/test_link_bonding.c
index 2f46e4c6ee..abf805fc3b 100644
--- a/app/test/test_link_bonding.c
+++ b/app/test/test_link_bonding.c
@@ -5171,4 +5171,4 @@ test_link_bonding(void)
 	return unit_test_suite_runner(&link_bonding_test_suite);
 }
 
-REGISTER_TEST_COMMAND(link_bonding_autotest, test_link_bonding);
+REGISTER_DRIVER_TEST(link_bonding_autotest, test_link_bonding);
diff --git a/app/test/test_link_bonding_mode4.c b/app/test/test_link_bonding_mode4.c
index 21c512c94b..6c2501523e 100644
--- a/app/test/test_link_bonding_mode4.c
+++ b/app/test/test_link_bonding_mode4.c
@@ -1674,4 +1674,4 @@ test_link_bonding_mode4(void)
 	return unit_test_suite_runner(&link_bonding_mode4_test_suite);
 }
 
-REGISTER_TEST_COMMAND(link_bonding_mode4_autotest, test_link_bonding_mode4);
+REGISTER_DRIVER_TEST(link_bonding_mode4_autotest, test_link_bonding_mode4);
diff --git a/app/test/test_link_bonding_rssconf.c b/app/test/test_link_bonding_rssconf.c
index 464fb2dbd0..771a44129b 100644
--- a/app/test/test_link_bonding_rssconf.c
+++ b/app/test/test_link_bonding_rssconf.c
@@ -728,4 +728,4 @@ test_link_bonding_rssconf(void)
 	return unit_test_suite_runner(&link_bonding_rssconf_test_suite);
 }
 
-REGISTER_TEST_COMMAND(link_bonding_rssconf_autotest, test_link_bonding_rssconf);
+REGISTER_DRIVER_TEST(link_bonding_rssconf_autotest, test_link_bonding_rssconf);
diff --git a/app/test/test_metrics.c b/app/test/test_metrics.c
index 11222133d0..917bee2e37 100644
--- a/app/test/test_metrics.c
+++ b/app/test/test_metrics.c
@@ -326,4 +326,4 @@ test_metrics(void)
 	return unit_test_suite_runner(&metrics_testsuite);
 }
 
-REGISTER_TEST_COMMAND(metrics_autotest, test_metrics);
+REGISTER_FAST_TEST(metrics_autotest, true, true, test_metrics);
diff --git a/app/test/test_pdcp.c b/app/test/test_pdcp.c
index 6c73c1db36..1ba5b4e074 100644
--- a/app/test/test_pdcp.c
+++ b/app/test/test_pdcp.c
@@ -1980,4 +1980,4 @@ test_pdcp(void)
 	return ret;
 }
 
-REGISTER_TEST_COMMAND(pdcp_autotest, test_pdcp);
+REGISTER_FAST_TEST(pdcp_autotest, false, true, test_pdcp);
diff --git a/app/test/test_pdump.c b/app/test/test_pdump.c
index ea03056b47..d0cc4fc5b5 100644
--- a/app/test/test_pdump.c
+++ b/app/test/test_pdump.c
@@ -219,4 +219,4 @@ test_pdump(void)
 	return TEST_SUCCESS;
 }
 
-REGISTER_TEST_COMMAND(pdump_autotest, test_pdump);
+REGISTER_FAST_TEST(pdump_autotest, true, false, test_pdump);
diff --git a/app/test/test_pmd_ring.c b/app/test/test_pmd_ring.c
index 86b1db2c1f..e83b9dd6b8 100644
--- a/app/test/test_pmd_ring.c
+++ b/app/test/test_pmd_ring.c
@@ -593,4 +593,4 @@ test_pmd_ring(void)
 	return unit_test_suite_runner(&test_pmd_ring_suite);
 }
 
-REGISTER_TEST_COMMAND(ring_pmd_autotest, test_pmd_ring);
+REGISTER_FAST_TEST(ring_pmd_autotest, true, true, test_pmd_ring);
diff --git a/app/test/test_pmd_ring_perf.c b/app/test/test_pmd_ring_perf.c
index d249b7de5f..3636df5c73 100644
--- a/app/test/test_pmd_ring_perf.c
+++ b/app/test/test_pmd_ring_perf.c
@@ -163,4 +163,4 @@ test_ring_pmd_perf(void)
 	return 0;
 }
 
-REGISTER_TEST_COMMAND(ring_pmd_perf_autotest, test_ring_pmd_perf);
+REGISTER_PERF_TEST(ring_pmd_perf_autotest, test_ring_pmd_perf);
diff --git a/app/test/test_rawdev.c b/app/test/test_rawdev.c
index 3c780e3f9e..d34691dacf 100644
--- a/app/test/test_rawdev.c
+++ b/app/test/test_rawdev.c
@@ -67,4 +67,4 @@ test_rawdev_selftests(void)
 
 #endif /* !RTE_EXEC_ENV_WINDOWS */
 
-REGISTER_TEST_COMMAND(rawdev_autotest, test_rawdev_selftests);
+REGISTER_FAST_TEST(rawdev_autotest, true, true, test_rawdev_selftests);
diff --git a/app/test/test_table.c b/app/test/test_table.c
index d100666e1c..27d2407517 100644
--- a/app/test/test_table.c
+++ b/app/test/test_table.c
@@ -206,4 +206,4 @@ test_table(void)
 
 #endif /* !RTE_EXEC_ENV_WINDOWS */
 
-REGISTER_TEST_COMMAND(table_autotest, test_table);
+REGISTER_FAST_TEST(table_autotest, true, true, test_table);
diff --git a/app/test/test_telemetry_data.c b/app/test/test_telemetry_data.c
index 31629a001b..59898ff5e9 100644
--- a/app/test/test_telemetry_data.c
+++ b/app/test/test_telemetry_data.c
@@ -615,4 +615,4 @@ telemetry_data_autotest(void)
 }
 #endif /* !RTE_EXEC_ENV_WINDOWS */
 
-REGISTER_TEST_COMMAND(telemetry_data_autotest, telemetry_data_autotest);
+REGISTER_FAST_TEST(telemetry_data_autotest, true, true, telemetry_data_autotest);
diff --git a/app/test/test_telemetry_json.c b/app/test/test_telemetry_json.c
index 5617eac540..758e89303f 100644
--- a/app/test/test_telemetry_json.c
+++ b/app/test/test_telemetry_json.c
@@ -213,4 +213,4 @@ test_telemetry_json(void)
 	return 0;
 }
 
-REGISTER_TEST_COMMAND(telemetry_json_autotest, test_telemetry_json);
+REGISTER_FAST_TEST(telemetry_json_autotest, true, true, test_telemetry_json);
diff --git a/app/test/test_vdev.c b/app/test/test_vdev.c
index 9f0e6c4b99..3e262f30bc 100644
--- a/app/test/test_vdev.c
+++ b/app/test/test_vdev.c
@@ -166,4 +166,4 @@ test_vdev(void)
 	return 0;
 }
 
-REGISTER_TEST_COMMAND(vdev_autotest, test_vdev);
+REGISTER_FAST_TEST(vdev_autotest, true, true, test_vdev);